package model;

import java.util.ArrayList;

public class Kamikaze extends Pawn {
    public Kamikaze(Position p, int color) {
        super(p, color);
    }

    @Override
    public ArrayList<Position> getAvailableMoves(Board b) {


        ArrayList<Position> moves = new ArrayList<Position>();
        Position arrival;


        // Self-Detonation Position no need for checks as the Kamikaze is already in place
        arrival = new Position(p.getX(),p.getY());
        moves.add(arrival);

        if(color == Piece.WHITE) { // black and white have an opposite direction behavior

            if(!hasBeenMoved){

                arrival = new Position(p.getX(),p.getY()+2);
                if(arrival.isCorrect() && b.isFree(arrival)) {moves.add(arrival);}

            }

            arrival = new Position(p.getX(),p.getY()+1);
            if(arrival.isCorrect() && b.isFree(arrival)) {moves.add(arrival);}

        }
        else {


            if(!hasBeenMoved){

                arrival = new Position(p.getX(),p.getY()-2);
                if(arrival.isCorrect() && b.isFree(arrival)) {moves.add(arrival);}

            }

            arrival = new Position(p.getX(),p.getY()-1);
            if(arrival.isCorrect() && b.isFree(arrival)) {moves.add(arrival);}

        }
        return moves;
    }
}
