package model;

import java.util.ArrayList;

public class Nwap extends Pawn {
    public Nwap(Position p, int color) {
        super(p, color);
    }

    @Override
    public ArrayList<Position> getAvailableMoves(Board b) {


        ArrayList<Position> moves = new ArrayList<Position>();
        Position arrival;


        if(color == Piece.WHITE) { // black and white have an opposite direction behavior

            if(!hasBeenMoved){

                //	up left 2
                arrival = new Position(p.getX()-2, p.getY() +2);
                if(arrival.isCorrect() && b.isFree(arrival)) { moves.add(arrival); }


                //	up left 2
                arrival = new Position(p.getX()+2, p.getY() +2);
                if(arrival.isCorrect() && b.isFree(arrival)) { moves.add(arrival); }

            }
            //	up left 1
            arrival = new Position(p.getX()-1, p.getY() +1);
            if(arrival.isCorrect() && b.isFree(arrival)) { moves.add(arrival); }


            //	up left 1
            arrival = new Position(p.getX()+1, p.getY() +1);
            if(arrival.isCorrect() && b.isFree(arrival)) { moves.add(arrival); }

            arrival = new Position(p.getX(),p.getY()+1);
            if(b.isEnemy(arrival,p)) {moves.add(arrival);}

        }
        else {


            if(!hasBeenMoved){

                //	up left 2
                arrival = new Position(p.getX()-2, p.getY() -2);
                if(arrival.isCorrect() && b.isFree(arrival)) { moves.add(arrival); }


                //	up left 2
                arrival = new Position(p.getX()+2, p.getY() -2);
                if(arrival.isCorrect() && b.isFree(arrival)) { moves.add(arrival); }

            }
            //	up left 1
            arrival = new Position(p.getX()-1, p.getY() -1);
            if(arrival.isCorrect() && b.isFree(arrival)) { moves.add(arrival); }


            //	up left 1
            arrival = new Position(p.getX()+1, p.getY() -1);
            if(arrival.isCorrect() && b.isFree(arrival)) { moves.add(arrival); }


            arrival = new Position(p.getX(),p.getY()-1);
            if(b.isEnemy(arrival,p)) {moves.add(arrival);}

        }
        return moves;
    }
}
